<?php
/*
Extension Name: Discussion Custom Prefix
Extension Url: http://lussumo.com/addons/
Description: Custom prefix for discussion.
Version: 0.01
Author: Roman "S" Vasiliev
Author Url: http://lussumo.com/community/account/8576/
*/

if(!defined('IN_VANILLA')) die();

// You should cut & paste this language definition into your conf/your_language
$Context->SetDefinition('LabelTextDiscussionPrefix', 'Prefix');
$Context->SetDefinition('SelectOptionNoPrefix', 'no prefix');


define('DCP_VERSION', 0.01);
define('DCP_PATH', $Configuration['EXTENSIONS_PATH'].'DiscussionCustomPrefix/');
define('DCP_ROOT', $Configuration['WEB_ROOT'].'extensions/DiscussionCustomPrefix/');
define('DCP_IMAGES', DCP_ROOT.'images/');

$DatabaseColumns['Discussion']['CustomPrefixID'] = 'CustomPrefixID';

@$_VERSION = FloatVal($Configuration['DCP_VERSION']);
if($_VERSION != DCP_VERSION) require DCP_PATH.'setup.php';

switch($Context->SelfUrl){
	case 'post.php':{
		$Context->AddToDelegate('DiscussionForm', 'DiscussionForm_PreTopicRender', 'DCP_DiscussionForm_PreTopicRender');
		//$Context->AddToDelegate('DiscussionForm', 'PreSaveDiscussion', 'DCP_PreSaveDiscussionForm');
		$Context->AddToDelegate('DiscussionManager', 'PreSaveDiscussion', 'DCP_PreSaveDiscussion');
		break;
	}
	case 'index.php':{
		$Context->AddToDelegate('DiscussionGrid', 'Constructor', 'DCP_SetDelegateParameter');
		$Context->AddToDelegate('DiscussionGrid', 'PreDiscussionOptionsRender', 'DCP_PreDiscussionOptionsRender');
		break;
	}
	case 'comments.php':{
		$Context->AddToDelegate('CommentGrid', 'Constructor', 'DCP_SetDelegateParameter');
		$Context->AddToDelegate('CommentGrid', 'PreRender', 'DCP_CommentsPreRender');
		//$Context->AddToDelegate('Discussion', 'PostDiscussionPrefix', 'DCP_PostDiscussionPrefix');
		break;
	}
	default: return;
}

$Context->AddToDelegate('DiscussionManager', 'PostGetDiscussionBuilder', 'DCP_PostGetDiscussionBuilder');
$Context->AddToDelegate('Discussion', 'PostGetPropertiesFromDataSet', 'DCP_PostGetPropertiesFromDataSet');
$Head->AddStyleSheet(DCP_ROOT.'style.css');

function GetDiscussionCustomPrefixSelect(&$Context, $Selected = 0){
	$S = $Context->ObjectFactory->NewContextObject($Context, 'Select');
	$S->Name = 'DiscussionCustomPrefix';
	//$S->CssClass = '';
	$S->SelectedValue = $Selected;
	include DCP_PATH.'config.php';
	$S->AddOption(0, $Context->GetDefinition('SelectOptionNoPrefix'));
	while(list($ID, $Info) = each($Config)) $S->AddOption($ID, $Info[0]);
	return $S;
}

function DCP_DiscussionForm_PreTopicRender(&$DiscussionForm){
	$Context =& $DiscussionForm->Context;
	$CustomPrefixID = @$DiscussionForm->Discussion->CustomPrefixID;
	$Text = $Context->GetDefinition('LabelTextDiscussionPrefix');
	$Label = "<label for='DiscussionCustomPrefix'>$Text</label>";
	$Select = GetDiscussionCustomPrefixSelect($Context, $CustomPrefixID)->Get();
	printf('<li>%s%s</li>', $Label, $Select);
}

function DCP_SetDelegateParameter(&$UnknownGrid){
	include DCP_PATH.'config.php'; // $Config
	$UnknownGrid->DelegateParameters['CustomPrefixConfig'] = $Config;
}

function DCP_PostGetDiscussionBuilder(&$DiscussionManager){
	$SqlBuilder =& $DiscussionManager->DelegateParameters['SqlBuilder'];
	$SqlBuilder->AddSelect('CustomPrefixID', 't');
}

function DCP_PostGetPropertiesFromDataSet(&$Discussion){
	$DataSet =& $Discussion->DelegateParameters['DataSet'];
	@$Discussion->CustomPrefixID = ForceInt($DataSet['CustomPrefixID'], 0);
}

/*function DCP_PreSaveDiscussionForm(&$DiscussionForm){
	$Discussion =& $DiscussionForm->DelegateParameters['SaveDiscussion'];
	$Discussion->CustomPrefixID = ForceIncomingInt('DiscussionCustomPrefix', 0);
	
}*/

function DCP_PreSaveDiscussion(&$DiscussionManager){
	$SqlBuilder =& $DiscussionManager->DelegateParameters['SqlBuilder'];
	$CustomPrefixID = ForceIncomingInt('DiscussionCustomPrefix', 0);
	$SqlBuilder->AddFieldNameValue('CustomPrefixID', $CustomPrefixID);
}

function GetCustomPrefixStyle(&$UnknownGrid, $CustomPrefixID, $bCommentGrid = False){
	$CustomPrefixConfig =& $UnknownGrid->DelegateParameters['CustomPrefixConfig'];
	$PrefixInfo = @$CustomPrefixConfig[$CustomPrefixID];
	if(!$PrefixInfo) return;
	$Style = "background-image:url($PrefixInfo[1]);";
	if(Is_Numeric($PrefixInfo[2])) $PrefixInfo[2] .= 'px';
	$WidthName = ($bCommentGrid) ? 'padding-right' : 'width';
	$Style .= "$WidthName:$PrefixInfo[2];";
	return $Style;
}

function DCP_PreDiscussionOptionsRender(&$DiscussionGrid){
	$Discussion =& $DiscussionGrid->DelegateParameters['Discussion'];
	$DiscussionList =& $DiscussionGrid->DelegateParameters['DiscussionList'];
	if($Discussion->CustomPrefixID){
		$Style = GetCustomPrefixStyle($DiscussionGrid, $Discussion->CustomPrefixID);
		if($Style != '') $DiscussionList .= "<div class='CustomPDG' style='$Style'></div>";
	}
}

function DCP_CommentsPreRender(&$CommentGrid){
	$Discussion =& $CommentGrid->Discussion;
	$CustomPrefixConfig =& $CommentGrid->DelegateParameters['CustomPrefixConfig'];
	if($Discussion->CustomPrefixID){
		$Style = GetCustomPrefixStyle($CommentGrid, $Discussion->CustomPrefixID, True);
		if($Style != '') $Discussion->Name = "<div class='CustomPrefixName' style='{$Style}'></div> ".$Discussion->Name;
	}
}

/*function DCP_PostDiscussionPrefix(&$Discussion){
	global $CommentGrid;
	$Prefix =& $Discussion->DelegateParameters['Prefix'];
	$Style = GetCustomPrefixStyle($CommentGrid, $Discussion->CustomPrefixID, True);
	if($Style != '') $Prefix = "<div class='CustomPrefixName' style='$Style'></div>";
}*/
?>